/*
 * BrokerGUI.java 
 */

package hotTip;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JPasswordField;
import java.io.*;
import java.util.*;

import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;

import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public class BrokerGUI implements ActionListener {

    JFrame converterFrame;
    JPanel converterPanel;

    JPasswordField password;
    JTextField hotTipFileName;
    JTextField ciphFileName; /* to write results to */

    JLabel pwdLabel;
    JLabel hotTipFNLabel;
    JLabel ciphFNLabel;

    JLabel working;

    JButton submit;

    Font font;

    public BrokerGUI() {

        //Create and set up the window.
        converterFrame = new JFrame("Login...");
        converterFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        converterFrame.setSize(new Dimension(120, 40));

        //Create and set up the panel.
        converterPanel = new JPanel(new GridLayout(2, 2));

        //Add the widgets.
        addWidgets();

        //Set the default button.
        converterFrame.getRootPane().setDefaultButton(submit);

        //Add the panel to the window.
        converterFrame.getContentPane().add(converterPanel, BorderLayout.CENTER);

        //Display the window.
        converterFrame.pack();
        converterFrame.setVisible(true);
    }

    /**
     * Create and add the widgets.
     *
     */
    private void addWidgets() {

        //Create widgets.

	password = new JPasswordField(2);
	password.setEchoChar('#'); 

	hotTipFileName = new JTextField(2);

	ciphFileName = new JTextField(2);

        pwdLabel = new JLabel("Password", SwingConstants.LEFT);
	pwdLabel.setLabelFor(password);

	ciphFNLabel = new JLabel("File name to write results to: ", SwingConstants.LEFT);
	ciphFNLabel.setLabelFor(ciphFileName);

	hotTipFNLabel = new JLabel("File containing broker message", SwingConstants.LEFT);
	hotTipFNLabel.setLabelFor(hotTipFileName);

	working = new JLabel("Working.........", SwingConstants.CENTER);

	font = new Font("Dialog",java.awt.Font.BOLD,48);
	working.setFont(font);

        submit = new JButton("Submit");        

        //Listen to events from the Submit button.
        submit.addActionListener(this);

        //Add the widgets to the container.
        converterPanel.add(pwdLabel);
        converterPanel.add(password);
	
        converterPanel.add(hotTipFNLabel);
        converterPanel.add(hotTipFileName);
        
	converterPanel.add(ciphFNLabel);
	converterPanel.add(ciphFileName);

	converterPanel.add(submit);

        pwdLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

        hotTipFNLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

	ciphFNLabel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    }

    public void actionPerformed(ActionEvent event) {
	
	char[] pwd = password.getPassword();

	converterPanel.removeAll();
	converterPanel.repaint();
	converterPanel.add(working);
	converterPanel.repaint();       

	/* read in contents of supplied file ... and create a String from them */

	FileReader fr = null;
	BufferedReader inFile = null;

	try {	    
	    fr = new FileReader(hotTipFileName.getText());
	    inFile =  new BufferedReader(fr);
	}

	catch(IOException iox) {
	    System.out.println(iox.getMessage());
	    iox.printStackTrace();
	}

	String str = null;
	String fileContents = new String();

	do {
	    
	    try {
		
		str = inFile.readLine();

		if ( str != null )
		    fileContents += str; 
	    }

	    catch(IOException iox) {

		System.out.println(iox.getMessage());
		iox.printStackTrace();
	    }

	} while (str != null);

	/* encrypt + MAC the contents of the hot tip file */ 

	/* here we're just writing the unencrypted unMAC'd output
	   directly to the output file -- needs to be fixed! */

	String output = fileContents;

	/* write output to the file specified */

	FileWriter fw = null;
	PrintWriter pw = null;

	try {
	    fw = new FileWriter(ciphFileName.getText());
	    pw = new PrintWriter( new BufferedWriter( fw ) );
	}

	catch(IOException iox) {	    
	    System.out.println(iox.getMessage());
	    iox.printStackTrace();
	}

	/* write to output file ... */
	pw.println(output);

	try {
	    pw.close();
	    fw.close(); }
	catch(IOException iox) {	    
	    System.out.println(iox.getMessage());
	    iox.printStackTrace();
	}

	/* optional: consider setting problem string (problemStr) on basis
	   of attempt to encrypt etc. so can report exception back and
	   display it on the windoe or if everything went OK can instead
	   give a sign-off message ... */

	String problemStr = null;

	if ( problemStr == null ) { /* everything appeared to have worked... */

	    JLabel allDone = new JLabel("Operations completed successfully; good bye.",
					SwingConstants.CENTER);

	    font = new Font("Dialog",java.awt.Font.BOLD,24);
	    allDone.setFont(font);

	    converterPanel.removeAll();
	    converterPanel.repaint();
	    converterPanel.add(allDone);
	    converterPanel.repaint(); 
	}

	else {
	    
	    JLabel prob = new JLabel("Operations failed:\t" + problemStr,
				     SwingConstants.CENTER);
	    
	    font = new Font("Dialog",java.awt.Font.BOLD,18);
	    prob.setFont(font);

	    converterPanel.removeAll();
	    converterPanel.repaint();
	    converterPanel.add(prob);
	    converterPanel.repaint(); 
	}	    
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {

        JFrame.setDefaultLookAndFeelDecorated(true);

        BrokerGUI converter = new BrokerGUI();
    }

    public static void main(String[] args) {

        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.

        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }

}
